#include <fcntl.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <wait.h>
#include <ctype.h>
#include <string.h>
#include <signal.h>
#include "wisio.h"
#include "Wtext.h"
/*
#define BS_KEY 8
#define TAB_KEY 9
#define ENTER_KEY 13
*/
#define COLS 80
#define ROWS 25
#define ROW row
#define ROW_O obj.row
class tobj
{
public:   int ppid,
              mywin,
              dev,
              shpid,
              termno,
              curx,/*cury,*/
              row,col,
              esc,seq,
              arg[8],
              cursor;
                 
          textobj text;
public:   void init(int ppid);
public:   void seq_exe(int chr);
public:   void seq_key(int chr);
public:   void esc_key(int chr);
public:   void ctrl_key(int chr);
public:   void add_chr(int chr);
public:   void writestr(char *str);
public:   void writenstr(char *str, int len);
/*public:   void update();*/
/*public:   void update_ctrl();*/
public:   void movecurs(int x, int y);
virtual  void WCkey(int cid, int key, int flags);
};
/*tobj;*/
int openpdev(char *devform,char *ttyform, char *ttyname)
{
    char name[32];
    int termno,dev;

    for ( termno = 0; termno<0xf; termno++)
    {
        sprintf(name,devform,termno);
        dev = open(name,O_RDWR+O_NONBLOCK);
        if (dev!=-1)
           break;
    }
    sprintf(ttyname,ttyform,termno);
    return dev;
}

int start(char *filetoexec,char *infile,char *outfile, char *errfile)
{ 
    int child;
    int termno;
    
    child=fork();
    switch(child)
    {
    case -1:
       return(-1);
    case 0:
       close(0);
       open(infile,O_RDONLY);
       close(1);
       open(outfile,O_WRONLY);
       dup2(1,2);
/*       close(2);
       open(errfile,O_WRONLY);       
       Wlog(27,"FORKED");*/
       execlp(filetoexec,filetoexec,NULL);
       Wlog(27,"EXECUTED");
       exit(0);
    default:
       return child;
    }
}


void tobj::init(int parent)
{
     int winc,i;
     ppid =parent;
     char ttyname[32];
    
     curx = 0;
/*     cury = 0;*/
     col=1;
     row=1;
     cursor = 0;
     text.setcolor(15,0);
     text.setfont("t2.font",6,9);
     text.setsize(80,25);
     winc = Wopenobj("Window");
     mywin =Wcreate_ctrl(winc,1,WIN_CTRL,0,100,80*text.sizex,25*text.sizey,64,"  WTERM");
     text.init(mywin);

     dev=openpdev("/dev/ptyp%x","/dev/ttyp%x",ttyname);
     shpid =start("/bin/sh",ttyname,ttyname,ttyname);
     Wsetpar(PAR_TIMER,10000);
     Wact_ctrl(text.getcid(0),1);
}

void tobj::seq_exe(int chr)
{
     int i;
     char ln[256];

     esc = 0;
     switch (chr)
     {
     case 'r':
         // !! SET SCROLLING REGION !! //
         break;
     case 'H':
//         movecurs(arg[2]-curx,arg[1]-row);
         if (seq >= 1)
            row=arg[1]-1; 
         else
            row = 1;
         if (seq >= 2)
            curx=arg[2]-1; 
         else
            curx = 0;
         break;
     case 'I':
          break;
          /* ???? */
     case 'J':
          for ( i= row ; i < ROWS; i++)
          {
             text.getline(row,ln);
             memset(ln,' ',COLS);
             ln[COLS+1] = 0;
             text.putline(row,ln);
          }
          break;
     default:
        add_chr('{');     
        add_chr('0'+seq);     
        add_chr(chr);     
        add_chr('}');     
        break;
     }
         
}
void tobj::seq_key(int chr)
{
     if (chr == ';')
     {
        seq +=1;
        memset(arg,0,sizeof(int)*8);
     }
     else if (isdigit(chr))
     {
        arg[seq] = arg[seq]*10+chr-'0';      
     }
     else
        seq_exe(chr);
}



void tobj::esc_key(int chr)
{
     if (seq)
     {
        seq_key(chr);
        return;
     }
     switch (chr)
     {
     case '[':
        seq = 1;
        arg[seq]=0;
        return;
     case 'D':
        movecurs(0,1);
        break;
     }
     esc = 0;
     return;
}

void tobj::ctrl_key(int chr)
{
     switch (chr)
     {
     case 8:                                      /* bs */
        movecurs(-1,0);
        break;
     case 9:                                      /* tab */
        movecurs(8-curx%8,0);
        break;
     case 10:                                     /* lf  */
        movecurs(-curx,1);
        break;
     case 27:
        esc = 1;
        seq = 0;
        break;
     }
}

void tobj::movecurs(int x, int y)
{
  int i;
  char *s,buff[256];

     curx+=x;
     if (curx<0)
        curx=0;
     while (curx >=80)
     {
         curx -= 80;
         y++;
     }
//     Wlog(17,"row");
     while (y>0)                                       /* Go down y lines */
     {
        row++;
        y--;
        if (row>text.rows)
        {
           text.scroll(1);/*row-text.rows)*/;
           row --/*= text.rows*/;
           Wlog(17,"row:%d",row);
        }
    }
    text.getline(row,buff);
    
    for (i=0,s=buff;i<curx; i++,s++)
       if (!*s)
          *s=' ';
    text.putline(row,buff);
    
}

void tobj::add_chr(int chr)
{
     char ln[256];
     if (esc)
         esc_key(chr);
     else if (chr<32)
        ctrl_key(chr);
     else
     {
        text.getline(row,ln);
        ln[curx] = chr;
        text.putline(row,ln);
        movecurs(1,0);
     }
}
void tobj::writestr(char *str)
{
   while (*str)
   {
      add_chr(*str++);
   }
   text.update();
   text.showcurs(2,curx,ROW);
}

void tobj::writenstr(char *str, int len)
{
   int i;
   for (i = 0; i<len; i++)
   {
      add_chr(*str++);
   }
   text.update();
   text.showcurs(2,curx,ROW);
}

void tobj::WCkey(int cid, int key, int flags)
{
    char chs[24];
    int len;
    len=0;
    if(flags & PRESS_KFL);
    else
       return;  
    switch( key)
    {
    case 0:
       break;
    case -1:
       break;
    default:
       if((key&0xFF) == 0)
          return;
       *chs= key;
       len =1;
       break;
    }
    if (len)
       write(dev,chs,len);
}

int mainmsgprocess()
{
   msg_win_cmd mes;
   int cid,ACT=0;
   char buff[1024];
   int nr,status;
   tobj obj;
   obj.dev =0;
   for(;;)
   {
      if (obj.dev)
      {
         nr=read(obj.dev,buff,sizeof(buff));
         if (nr>0)
            obj.writenstr(buff,nr);  
         else
            if (waitpid(obj.shpid,&status,WNOHANG)==obj.shpid)
            {
                obj.dev = 0;
                Wsendcmd(MAINQUE,CMD_DELTSK,PEND);
            }

      }
      Wgetcmd(&mes);
      switch (mes.cmd)
      {
         case CMD_UPDPTR:
            if (mes.flg == 4)
               Wact_ctrl(obj.text.getcid(0),1);
            break;
	 case CMD_INICTL:
            obj.init(mes.pid);
	    break;
         case CMD_ACTCTL:
            obj.text.showcurs(mes.flg & 1,obj.curx,ROW_O);
            break;
         case CMD_ADDKEY:
              obj.WCkey(mes.cid,mes.idx,mes.flg);
              break;                      
         case CMD_DELTSK:
              if (obj.dev)
                 kill(obj.shpid,1);
              return(0);
         default:
            break;
      }
      Wdefault_msg(&mes);
   }
}

main(int argc,char *argv[])
{
   Wloglevel = 99;
   mainmsgprocess();
}


